Package org.apache.tapestry5.commons.services

## Interface InvalidationEventHub

- All Known Subinterfaces:
    `InternalComponentInvalidationEventHub`, `MessagesSource`, `ResourceChangeTracker`, `ResourceDigestManager`
  All Known Implementing Classes:
    `ComponentTemplateSourceImpl`, `InternalComponentInvalidationEventHubImpl`, `InvalidationEventHubImpl`, `MessagesSourceImpl`, `ResourceChangeTrackerImpl`, `ResourceDigestManagerImpl`

      public interface InvalidationEventHub

  An object which manages a list of `InvalidationListener`s. There are multiple event hub services implementing this interface, each with a specific marker annotation; each can register listeners and fire events; these are based on the type of resource that has been invalidated. Tapestry has built-in support for:
  message catalog resources
    ComponentMessages marker annotation
  component templates
    ComponentTemplates marker annotation
  component classes
    ComponentClasses marker annotation
  Starting in Tapestry 5.3, these services are disabled in production (it does nothing).
  Since:
    5.1.0.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addInvalidationCallback​(Runnable callback)` | Adds a callback that is invoked when an underlying tracked resource has changed.
    `void` | `addInvalidationListener​(InvalidationListener listener)` | Deprecated. in 5.4, use `addInvalidationCallback(Runnable)` instead}
    `void` | `clearOnInvalidation​(Map<?,​?> map)` | Adds a callback that clears the map.

- - ### Method Detail

    - #### addInvalidationListener

          void addInvalidationListener​(InvalidationListener listener)

      Deprecated.
      in 5.4, use `addInvalidationCallback(Runnable)` instead}
      Adds a listener, who needs to know when an underlying resource of a given category has changed (so that the receiver may discard any cached data that may have been invalidated). Does nothing in production mode.

    - #### addInvalidationCallback

          void addInvalidationCallback​(Runnable callback)

      Adds a callback that is invoked when an underlying tracked resource has changed. Does nothing in production mode.
      Since:
        5.4

    - #### clearOnInvalidation

          void clearOnInvalidation​(Map<?,​?> map)

      Adds a callback that clears the map.
      Since:
        5.4